﻿using C1.WPF;
using C1.WPF.Theming;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Wpf_C1ComboBox
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<Employee> emp = new ObservableCollection<Employee>();
        public MainWindow()
        {
            InitializeComponent();
        }

        private void StackPanel_Loaded(object sender, RoutedEventArgs e)
        {
            C1.WPF.Theming.C1Theme.ApplyTheme(c1ComboBox, C1Theme.GetCurrentThemeResources(new C1.WPF.Theming.ShinyBlue.C1ThemeShinyBlue()));

            emp.Add(new Employee() { ID = 101, Name = "John", Department = "Dev Tools", Location = "US" });
            emp.Add(new Employee() { ID = 102, Name = "Mike", Department = "Development", Location = "UK" });
            emp.Add(new Employee() { ID = 103, Name = "Fuller", Department = "R&D", Location = "US" });
            emp.Add(new Employee() { ID = 104, Name = "Lilly", Department = "HR", Location = "Japan" });
            emp.Add(new Employee() { ID = 105, Name = "Prabhat", Department = "Accounts", Location = "India" });
            emp.Add(new Employee() { ID = 106, Name = "Richa", Department = "HR", Location = "India" });
            emp.Add(new Employee() { ID = 107, Name = "Miller", Department = "Dev Tools", Location = "US" });
            emp.Add(new Employee() { ID = 108, Name = "Sam", Department = "Dev Tools", Location = "UK" });

            this.DataContext = emp;

            c1ComboBox.SelectedItemChanged += c1ComboBox_SelectedItemChanged;
           
            c1ComboBox.IsKeyboardFocusWithinChanged += c1ComboBox_IsKeyboardFocusWithinChanged;
            c1ComboBox.IsKeyboardFocusedChanged += c1ComboBox_IsKeyboardFocusedChanged;
         }

        void c1ComboBox_IsKeyboardFocusedChanged(object sender, DependencyPropertyChangedEventArgs e)
        {
            UpdateFocus();
        }
        void c1ComboBox_IsKeyboardFocusWithinChanged(object sender, DependencyPropertyChangedEventArgs e)
        {
            UpdateFocus();
        }
        private void UpdateFocus()
        {
            this.Dispatcher.BeginInvoke(new Action(delegate
            {
                // handle both properties, as ComboBox is complicated control, can have different combination of this properties
                if (c1ComboBox.IsKeyboardFocused || c1ComboBox.IsKeyboardFocusWithin) 
                {
                    c1ComboBox.IsDropDownOpen = true;
                }
                else
                {
                    c1ComboBox.IsDropDownOpen = false;
                }
            }));
        }

        int index;
        void c1ComboBox_SelectedItemChanged(object sender, C1.WPF.PropertyChangedEventArgs<object> e)
        {
            //Get the index position of the currently selected item in the ComboBox
            index = c1ComboBox.SelectedIndex;
            //Get the Item
            Employee emp1 = (Employee)c1ComboBox.SelectedItem;

            if (index >= 0)
            {
            c1ComboBox.ItemsSource = null;
            //Remove the item from its original index in the Collection
            emp.RemoveAt(index);
            //Insert it in the first place in the Collection
            emp.Insert(0, emp1);
            c1ComboBox.ItemsSource = emp;
            }
        }
   
    }
    public class Employee
    {
        public int ID { get; set; }
        public string Name { get; set; }
        public string Department { get; set; }
        public string Location { get; set; }

        public override string ToString()
        {
            return ID+" "+Name+" "+Department+" "+Location;
        }
    }

}
